=== debian/changelog ===
yyjson (0.4.0) unstable; urgency=medium

  * Initial Release.

 -- STV Electronic GmbH <h.kempkensteffen@stv-electronic.de>  Fri, 04 Mar 2022 09:38:53 +0000
