=== debian/control ===
Source: yyjson
Priority: optional
Maintainer: STV Electronic GmbH <h.kempkensteffen@stv-electronic.de>
Standards-Version: 4.4.1
Section: libs
Build-Depends:
 build-essential,
 cmake,
 git,
 debhelper,
 dh-make,
 quilt,
 fakeroot,
 lintian
Homepage: https://github.com/ibireme/yyjson

Package: libyyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyyjson (= ${binary:Version}), ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

Package: libyyjson
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A high performance JSON library written in ANSI C.
