=== debian/changelog ===
yyjson (0.8.0-0deepin) unstable; urgency=medium

  * modify changelog and format

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 23 Nov 2023 22:26:45 +0800

yyjson (0.8.0) UNRELEASED; urgency=medium

  * New upstream version
  * Add `YYJSON_SUBTYPE_NOESC` subtype to mark strings that do not need to be escaped.
  * Add `YYJSON_DISABLE_UTF8_VALIDATION` flag to allow disable UTF-8 validation at compile-time.
  * Add dynamic allocator API: `yyjson_alc_dyn_new()`, `yyjson_alc_dyn_free()`.
  * Add the missing `yyjson_mut_obj_add_arr/obj()` API: #140
  * Improve the write performance of strings with `YYJSON_SUBTYPE_NOESC`.
  * Fix clang-16 valgrind fail: #134
  * Fix compile break when both `FAST_FP` and `READER` are disabled

 -- zhangkun <zhangkun2@uniontech.com>  Tue, 03 Oct 2023 17:23:14 +0800

yyjson (0.7.0) UNRELEASED; urgency=medium

  * Initial Release.

 -- xiangzelong <xiangzelong@deepin.org>  Tue, 20 Jun 2023 16:30:45 +0800
