=== debian/control ===
Source: yyjson
Priority: optional
Maintainer: unknown <xiangzelong@deepin.org>
Build-Depends: debhelper-compat (= 13),
                libmpfr-dev,
                libgmp-dev,
                cmake,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/ibireme/yyjson
Rules-Requires-Root: no

Package: yyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: yyjson (= ${binary:Version}), ${misc:Depends}
Description: A high performance JSON library written in ANSI C.

Package: yyjson
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A high performance JSON library written in ANSI C.
