=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DYYJSON_BUILD_TESTS=ON \
