## yyjson 0.9.0+ds

=== debian/changelog ===
yyjson (0.9.0+ds-2) unstable; urgency=medium

  * Source only upload.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Thu, 30 May 2024 15:22:46 -0300

yyjson (0.9.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #972804)

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Tue, 14 May 2024 01:14:30 -0300
