## yyjson 0.10.0+ds

=== debian/changelog ===
yyjson (0.10.0+ds-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 22 Aug 2024 19:45:33 -0700

yyjson (0.10.0+ds-1) unstable; urgency=medium

  * New upstream version 0.10.0+ds.
  * debian/libyyjson0.symbols: add symbols from new release.

 -- Carlos Henrique Lima Melara <charlesmelara@riseup.net>  Tue, 23 Jul 2024 22:54:50 +0900
