## yyjson 0.12.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DYYJSON_BUILD_DOC=ON \
	-DYYJSON_BUILD_TESTS=ON
